{***************************************************************************
 *                                                                         *
 *                 POWER-GRAPH      Programme principal                    *
 *                                                                         *
 ***************************************************************************}

{$A+,B-,D+,E-,F+,G+,I+,L+,N-,O-,R-,S+,V-,X-}
{$M 16384,0,655360}

PROGRAM PowerGraph;

 USES
     Crt,
     Graph,
     DMenus_2,
     DTWin,

     PG_Ptrs,
     PG_Calc,
     ChgVar,
     PG_Draw,
     PG_GrScr,
     SaveScrn,
     PG_Disk,
     PG_Clav,
     PG_TxScr;


 CONST RootMenu:MenuPtr=NIL;
       L:ProjListPtr=NIL;

 VAR
    Ch:CHAR;
    i:BYTE;


 PROCEDURE Dess(l:ProjListPtr);

  VAR driver,error,modegr,i:INTEGER;
      palette:palettetype;

  BEGIN
       driver:=ModNam;modegr:=nmode;
       InitGraph(driver,ModeGr,PGPath);
       Draw(l);
       WriteScreen;
       repeat until keypressed;
       CloseGraph;
  END; {Dess}


 PROCEDURE PG_Scrn_Display;

  VAR x,y,lg:BYTE;

  BEGIN
       IF l=NIL THEN BEGIN
                          WINDOW(1,2,80,TreeHi-1);
                          GrayOnBlack;
                          ClrScr;
                          WINDOW(1,1,80,25);
                          EXIT;
                     END;
       MakeTreeWin(TreeWin,l);
       CASE LENGTH(PosInTree) OF
            1 : BEGIN x:=1;y:=NthProjList(l,Ord(PosInTree[1]))^.YPos;
                      lg:=LENGTH(NthProjList(l,Ord(PosInTree[1]))^.Name);END;
            2 : BEGIN x:=NthProject(NthProjList(l,Ord(PosInTree[1]))^.Proj,
                       Ord(PosInTree[2]))^.XPos;
                      y:=NthProject(NthProjList(l,Ord(PosInTree[1]))^.Proj,
                       Ord(PosInTree[2]))^.YPos;
                      lg:=LENGTH(NthProject(NthProjList(l,Ord(PosInTree[1]))^.Proj,
                       Ord(PosInTree[2]))^.Name);
                      END;
            3 : BEGIN x:=NthEqu(NthProject(NthProjList(l,
                       Ord(PosInTree[1]))^.Proj,Ord(PosInTree[2]))^.Cond,
                       Ord(PosInTree[3]))^.XPos;
                      y:=NthEqu(NthProject(NthProjList(l,
                       Ord(PosInTree[1]))^.Proj,Ord(PosInTree[2]))^.Cond,
                       Ord(PosInTree[3]))^.YPos;
                      lg:=LENGTH(NthEqu(NthProject(NthProjList(l,
                       Ord(PosInTree[1]))^.Proj,Ord(PosInTree[2]))^.Cond,
                       Ord(PosInTree[3]))^.Name);
                       END;
            END; {case}
       IF y>=TreeHi
          THEN TreeWin^.YPos:=y-TreeHi+2
          ELSE TreeWin^.YPos:=1;
       GrayOnBlack;
       WINDOW(1,2,80,TreeHi+1);
       IF MEM[$B800:(TreeHi+1)*160]=$C4 THEN WINDOW(1,2,80,TreeHi+2);
       ClrScr;
       WINDOW(1,1,80,TreeHi+1);
       RefreshTWin(TreeWin);
       WINDOW(1,2,80,25);
       GOTOXY(1,TreeHi);
       WRITE('');
       FOR i:=0 to lg-1 DO
           MEM[$B800:160*(y-TreeWin^.YPos+1)+2*(x-1+i)+1]:=LightGray+Blink;
       WINDOW(1,1,80,25);
  END; {PG_Scrn_Display}


{**********************************************************
 *            Procdures appelle hors-menu               *
 **********************************************************}

 PROCEDURE InfoProjet;

  VAR
     w:TWinPtr;
     s:STRING;
     ll:ProjListPtr;

  BEGIN
       ll:=NthProjList(l,Ord(PosInTree[1]));
       OpenTWin(w,15,10,65,16,Cadre,48,8);
       TWinWrite(w,5,2,'Projet "'+ll^.Name+'"');
       s:='';
       FOR i:=1 TO MaxDeg DO
           BEGIN
                s:=s+ll^.Pal.Names[i];
                IF i<>MaxDeg THEN s:=s+' / ';
           END;
       TWinWrite(w,2,4,'Palette : '+s);
       REPEAT UNTIL KeyPressed;
       CloseTWin(w);
  END; {InfoProject}


{**********************************************************
 *                Procdures des menus                    *
 **********************************************************}

{***** Menu Fichiers *****}



{***** Menu Projets *****}

 PROCEDURE Lire;
  VAR Tmp:ProjListPtr;
  BEGIN
       GrayOnBlack;
       IF l=NIL
          THEN Load(l)
          ELSE BEGIN
                    Tmp:=NIL;
                    Load(Tmp);
                    LastProjList(l)^.Next:=Tmp;
               END;
        IF l<>NIL THEN
        IF PosInTree=''
          THEN PosInTree:=#1
          ELSE REPEAT
                     PosInTree:=SUCC(PosInTree[1]);
               UNTIL NthProjList(l,Ord(PosInTree[1]))^.Next=NIL;
  END;{lire}


 PROCEDURE Sauve;
  BEGIN
       GrayOnBlack;
       Save(l);
  END;


 PROCEDURE NouveauProjet;

  VAR
     ll:ProjListPtr;

  BEGIN
       GrayOnBlack;
       New(ll);
       ll^.Next:=NIL;ll^.Proj:=NIL;
       ll^.Pal:=DefaultPalette;
       WRITE('Nom du projet : ');
       READLN(ll^.Name);
       IF ll^.Name='' THEN ll^.Name:='NoName';
       EnterSurf(ll^.Proj);
       IF ll^.Proj=NIL
          THEN BEGIN
                    DISPOSE(ll);
                    ll:=NIL;
                    END;
       IF ll<>NIL THEN
          IF l=NIL
             THEN BEGIN
                       l:=ll;
                       PosInTree:=#1;
                  END
             ELSE BEGIN
                       LastProjList(l)^.Next:=ll;
                  END;
 END;{NouveauProjet}


 PROCEDURE RenameProject;

  BEGIN
       GOTOXY(TreeHi+5,20);
       TextColor(LightGray);
       TextBackGround(Black);
       WRITE('Nouveau nom du projet : ');
       READLN(NthProjList(L,Ord(PosInTree[1]))^.Name);
  END; {RenameProject}


 PROCEDURE RemoveProject;

  VAR tp:ProjListPtr;

  BEGIN
       if PosInTree='' THEN EXIT;
       tp:=NthProjList(L,Ord(PosInTree[1]));
       DelProject(tp^.Proj);
       IF PosInTree[1]=#1
          THEN L:=tp^.next
          ELSE NthProjList(L,Ord(PRED(PosInTree[1])))^.Next:=tp^.Next;
       IF tp^.Next=NIL
          THEN PosInTree:=PRED(PosInTree[1])
          ELSE PosInTree:=PosInTree[1];
       IF PosInTree=#0 THEN PosInTree:='';
       DISPOSE(tp);
  END; {RemoveProject}


 PROCEDURE ChangePalette;

  BEGIN
       ModifyPalette(NthProjList(l,Ord(PosInTree[1])));
  END; {ChangePalette}


{***** Menu Equations *****}

 PROCEDURE NouvelleSurface;

  VAR
     tl:ProjListPtr;
     tp:ProjectPtr;
     flag:BOOLEAN;

  BEGIN
       GrayOnBlack;
       CASE PosInTree[0] OF
            #0 : BEGIN
                      GOTOXY(3,5);
                      WRITELN('Crez un projet d''abord, vous faites ch..r le programmeur.');
                      WRITELN('      et pressez une touche, pour la peine.');
                      WRITELN('                 (bord''s!)');
                      REPEAT UNTIL KeyPressed;
                      EXIT;
                 END;
            #1,#3 : PosInTree:=PosInTree[1]+#1;
            END;
            tl:=NthProjList(l,Ord(PosInTree[1]));
            IF tl^.Proj<>NIL
               THEN BEGIN
                         REPEAT
                               tp:=NthProject(tl^.Proj,Ord(PosInTree[2]));
                               PosInTree[2]:=SUCC(PosInTree[2]);
                         UNTIL tp^.Next=NIL;
                         EnterSurf(tp^.Next);
                    END
               ELSE EnterSurf(tl^.Proj);
  END; {NouvelleSurface}


 PROCEDURE NouvelleCond;

  VAR
     tp:ProjectPtr;
     tc:EquPtr;
     flag:BOOLEAN;

  BEGIN
       GrayOnBlack;
       CASE PosInTree[0] OF
            #0 : BEGIN
                      GOTOXY(3,5);
                      WRITELN('Crez un projet d''abord, vous faites ch..r le fiss.');
                      WRITELN('      et pressez une touche, pour la peine.');
                      WRITELN('                      (c''est vrai, quoi, bord''s!)');
                      REPEAT UNTIL KeyPressed;
                      EXIT;
                 END;
            #1 : BEGIN
                      GOTOXY(3,5);
                      WRITELN('Impossible....');
                      REPEAT UNTIL KeyPressed;
                      EXIT;
                 END;
            #2 : PosInTree:=PosInTree+#1;
            END;
            tp:=NthProject(NthProjList(l,Ord(PosInTree[1]))^.Proj,Ord(PosInTree[2]));
            IF tp^.Cond<>NIL
               THEN BEGIN
                         REPEAT
                               tc:=NthEqu(tp^.Cond,Ord(PosInTree[3]));
                               PosInTree[3]:=SUCC(PosInTree[3]);
                         UNTIL tc^.Next=NIL;
                         EnterCond(tc^.Next);
                    END
               ELSE EnterCond(tp^.Cond);
  END; {NouvelleCond}


  PROCEDURE EquRotation;

   VAR
      t,f,a:REAL;
      tP:XYZPtr;
      tP1:ProjectPtr;

   PROCEDURE lecture;
    BEGIN
         WRITE('Angle entre Ox et la trace de D dans Oxy : ');
         READLN(t);
         t:=t/180*pi;
         WRITE('Angle entre D et Oz : ');
         READLN(f);
         f:=f/180*pi;
         WRITE('Angle de rotation : ');
         READLN(a);
         a:=a/180*pi;
    END;{lecture}

    BEGIN
        CASE PosInTree[0] OF
             #0 : BEGIN
                       GOTOXY(10,10);
                       WRITELN('Ca ne serait pas plus fay''s en crant un projet d''abord ?');
                       REPEAT UNTIL KeyPressed;
                  END;
             #1 : BEGIN
                       GOTOXY(10,10);
                       WRITELN('Choisissez un quation d''abord !');
                       REPEAT UNTIL KeyPressed;
                  END;
             #2 : BEGIN
                       lecture;
                       tP1:=NthProject(NthProjList(l,Ord(PosInTree[1]))^.Proj,Ord(PosInTree[2]));
                       XYZRotate(tP,tP1^.P,a,t,f);
                       DelXYZ(tP1^.P);
                       tP1^.P:=tP;
                  END;
             #3 :;
             END; {case}
   END; {EquRotation}



{***** Menu Systme *****}

 PROCEDURE Dessine;
 BEGIN
      Dess(NthProjList(l,Ord(PosInTree[1])));
 END; {Dessine}


{****** Menu Image ****** }

 PROCEDURE SauveImage;

  VAR s:STRING[8];

  BEGIN
       ClrScr;
       WRITE('Nom du fichier : ');
       READLN(s);
       SaveScreen(s);
  END; {SauveImage}


 PROCEDURE AfficheImage;

  VAR s:STRING[8];

  BEGIN
       ClrScr;
       WRITE('Nom du fichier : ');
       READLN(s);
       ReadScreen(s);
  END; {AfficheImage}


 BEGIN
{***************************************************************
 *                    Dfinition menus                         *
 ***************************************************************}

 AddMenu(RootMenu,'Fichiers',1,3,19,NIL);
 WITH RootMenu^ DO BEGIN
      AddMenu(SM,'Rpertoire',1,2,0,@ListeRepert);
      AddMenu(SM,'Change Rpertoire',1,2,0,@ChangeRep);
      AddMenu(SM,'Renomme',3,2,0,NIL);
      AddMenu(SM,'Efface',1,2,0,NIL);
      AddMenu(SM,'Quitte      ALT-X',1,2,0,@DMenus_2.Quitte);
 END;

 AddMenu(RootMenu,'Projets',1,13,12,NIL);
 WITH RootMenu^.Next^ DO BEGIN
      AddMenu(SM,'Nouveau',1,12,0,@NouveauProjet);
      AddMenu(SM,'Charge',1,12,0,@Lire);
      AddMenu(SM,'Sauve',1,12,0,@Sauve);
      AddMenu(SM,'Duplique',1,12,14,NIL);
        WITH SM^.Next^.Next^.Next^ DO BEGIN
             AddMenu(SM,'vers Nouveau',6,23,0,NIL);
             AddMenu(SM,'Ajoute',1,23,0,NIL);
        END;
      AddMenu(SM,'Fusionne',1,12,0,NIL);
      AddMenu(SM,'Renomme',1,12,0,@RenameProject);
      AddMenu(SM,'Efface',1,12,0,@RemoveProject);
      AddMenu(SM,'Palette',1,12,0,@ChangePalette);
      AddMenu(SM,'Oprations',1,12,13,NIL);
        WITH SM^.Next^.Next^.Next^.Next^.Next^.Next^.Next^.Next^ DO BEGIN
             AddMenu(SM,'Translation',1,23,0,NIL);
             AddMenu(SM,'Rotation',1,23,0,NIL);
             AddMenu(SM,'Homothtie',1,23,0,NIL);
             AddMenu(SM,'Affinit',1,23,0,NIL);
        END;
 END;

 AddMenu(RootMenu,'Equations',1,22,12,NIL);
 WITH RootMenu^.Next^.Next^ DO BEGIN
      AddMenu(SM,'Nouvelle',1,21,11,NIL);
        WITH SM^ DO BEGIN
             AddMenu(SM,'Surface',1,32,0,@NouvelleSurface);
             AddMenu(SM,'Condition',1,32,0,@NouvelleCond);
        END;
      AddMenu(SM,'Efface',1,21,0,NIL);
      AddMenu(SM,'Transfre',1,21,0,NIL);
      AddMenu(SM,'Duplique',1,21,0,NIL);
      AddMenu(SM,'Renomme',1,21,0,NIL);
      AddMenu(SM,'Edite',3,21,0,NIL);
      AddMenu(SM,'Oprations',1,21,13,NIL);
        WITH SM^.Next^.Next^.Next^.Next^.Next^.Next^ DO BEGIN
             AddMenu(SM,'Translation',1,32,0,NIL);
             AddMenu(SM,'Rotation',1,32,0,@EquRotation);
             AddMenu(SM,'Homothtie',1,32,0,NIL);
             AddMenu(SM,'Affinit',1,32,0,NIL);
        END;
 END;

 AddMenu(RootMenu,'Systme',1,33,17,NIL);
 WITH RootMenu^.Next^.Next^.Next^ DO BEGIN
      AddMenu(SM,'Mode Graphique',1,32,0,@ScrParam);
      AddMenu(SM,'Trace',1,32,0,@Dessine);
      AddMenu(SM,'Sauve Config',1,32,0,NIL);
      AddMenu(SM,'Restaure Config',1,32,0,NIL);
      AddMenu(SM,'Param. de trac',2,32,0,NIL);
 END;

 AddMenu(RootMenu,'Images',1,42,9,NIL);
 WITH RootMenu^.Next^.Next^.Next^.Next^ DO BEGIN
      AddMenu(SM,'Affiche',1,41,0,@AfficheImage);
      AddMenu(SM,'Sauve',1,41,0,@SauveImage);
 END;


{********************************************************}

 WINDOW(1,1,80,25);
 GrayOnBlack;
 ClrScr;
 AfficheBarre(RootMenu,Black,Red,LightGray,0);
 OpenTWin(TreeWin,1,2,80,TreeHi-1,PasDeCadre,80,0);
 SetTWinColor(TreeWin,LightGray,Black);

REPEAT
      PG_Scrn_Display;
      Ch:=ReadKey;

      CASE Ch OF
           #0 : CASE ReadKey OF
                #68 : {F10}
                      BEGIN
                           MenuGo(RootMenu,Black,Red,LightGray,
                             @PG_Scrn_Display,#68,#45);     {F10 et Alt-x}
                           AfficheBarre(RootMenu,Black,Red,LightGray,0);
                      END;
                #45 : {Alt-X}
                      AllStop:=TRUE;
                #72 : {haut}
                      CASE LENGTH(PosInTree) OF
                           1 : IF PosInTree[1]<>#1 THEN PosInTree:=
                                    PRED(PosInTree[1]);
                           ELSE IF PosInTree[2]>#1 THEN PosInTree:=
                                     PosInTree[1]+PRED(PosInTree[2])
                           END;
                #80 : {bas}
                      CASE LENGTH(PosInTree) OF
                           1 : IF (NthProjList(l,Ord(PosInTree[1]))^.Next<>NIL)
                                    AND (l<>NIL)
                                  THEN PosInTree:=SUCC(PosInTree[1]);
                           ELSE IF NthProject(NthProjList(l,
                                      Ord(PosInTree[1]))^.Proj,
                                       Ord(PosInTree[2]))^.Next<>NIL
                                   THEN PosInTree:=PosInTree[1]+SUCC(PosInTree[2]);
                           END;
                #77 : {droite}
                      CASE LENGTH(PosInTree) OF
                           1 : IF l<>NIL
                                  THEN PosInTree:=PosInTree+#1;
                           2 : IF NthProject(NthProjList(l,Ord(PosInTree[1]))^.Proj,Ord(PosInTree[2]))^.Cond<>NIL
                                  THEN PosInTree:=PosInTree+#1;
                           3 : IF NthEqu(NthProject(NthProjList(l,
                                     Ord(PosInTree[1]))^.Proj,
                                      Ord(PosInTree[2]))^.Cond,
                                       Ord(PosInTree[3]))^.Next<>NIL
                                  THEN PosInTree:=COPY(PosInTree,1,2)+SUCC(PosInTree[3]);
                           END;
                #75 : {gauche}
                      CASE LENGTH(PosInTree) OF
                           2 : PosInTree:=PosInTree[1];
                           3 : IF PosInTree[3]=#1
                                  THEN PosInTree:=COPY(PosInTree,1,2)
                                  ELSE PosInTree:=COPY(PosInTree,1,2)+PRED(PosInTree[3]);
                           END;
                #73 : {PgUp}
                      IF PosInTree[1]>#1 THEN PosInTree:=PRED(PosInTree[1]);
                #81 : {PgDn}
                      IF (NthProjList(l,Ord(PosInTree[1]))^.Next<>NIL)
                                    AND (l<>NIL)
                                  THEN PosInTree:=SUCC(PosInTree[1]);
                #132 : {CTRL-PgUp}
                       IF TreeHi>3 THEN DEC(TreeHi);
                #118 : {CTRL-PgDn}
                       IF TreeHi<20 THEN INC(TreeHi);
                END; {case #0}
           #13 : CASE PosInTree[0] OF
                 #1 : InfoProjet;
                 #2 : {Affiche quation/couleur surface};
                 #3 : {Affiche quation condition};
                 END; {Case #13}
           END; {case Ch}
UNTIL AllStop;

IF l<>NIL THEN DelProjList(l);
CloseTWin(TreeWin);
CHDIR(PGPath);
TextColor(White);
TextBackGround(Black);

END.
