{***************************************************************************
 *                                                                         *
 *                     Unit de dessin de POWER-GRAPH                      *
 *                                                                         *
 ***************************************************************************}

{$A+,B-,D+,E-,F+,G+,I+,L+,N-,O-,R-,S+,V-,X-}
{$M 16384,0,655360}

UNIT PG_DRAW;

INTERFACE

 USES
     Graph,
     Crt,

     PG_Ptrs,
     PG_Calc,
     PG_GrScr;

 PROCEDURE Draw(L:ProjListPtr);


IMPLEMENTATION

 PROCEDURE Draw(L:ProjListPtr);

  VAR i,j:INTEGER;
      x,y,z,r,r1,r2:REAL;
      c:BYTE;
      N,E:CProjectPtr;
      Xp:RealPtr;
      nor:vec3;
      v:StructPtr;


  BEGIN
       IF l=NIL THEN EXIT;
       RANDOMIZE;
       r1:=COS(1)/SIN(1);
       YPos:=(YMax+1) DIV 2;ZPos:=(ZMax+1) DIV 2;
       N:=NIL;
       V:=NIL;
       CProjectInit(L^.Proj,N);
       SetAllPalette(L^.Pal);
       SetBkColor(15);
       FOR i:=YPos-100 TO YPos+100 DO
           BEGIN IF KEYPRESSED AND (READKEY=#27) THEN EXIT;
                 y:=(i-YPos)/YCoef;
                 Copy_All_QX_to_QY(N);
                 Add_All_QXY_to_QY(N,y);
                 FOR j:=ZPos-100 TO ZPos+100 DO
                     BEGIN Z:=(ZPos-j)/ZCoef;
                           Copy_All_QY_to_Q(N);
                           Add_All_QXYZ_to_Q(N,y,z);
                           FindRoots(N,V);
                           Choose(V,Xp,E);
                           IF xp<>NIL THEN
                              WITH E^ DO BEGIN
                                   x:=xp^;
                                   Normale(E,x,y,z,nor);
                                   r2:=RANDOM(255)/255;
                                   r:=ABS(nor[1]);
                                   r:=3*r1*SIN(r)/COS(r);
                                   IF r2>1+TRUNC(r)-r THEN r:=r+1;
                                   C:=Colors[coul,TRUNC(r)];
                                   PutPixel(i,j,c);
                              END;
                           Del_All_Q(N);
                     END;
                 Del_All_QY(N);
           END;
  END; {Draw}

END.
