{$A+,B-,D-,E-,F+,G-,I-,L-,N-,O-,R-,S+,V-,X-}

{************************************************************************
 *                                                                      *
 *                          Unit Menus v2.1                            *
 *                                                                      *
 *           FreeWare in the Boquette by Dwitch  132 An 191             *
 *                                                                      *
 *                             4 Juin 1992                              *
 *                                                                      *
 ************************************************************************}

UNIT DMenus_2;

INTERFACE

 Uses CRT,
      Console;

 TYPE
     MenuPtr=^Menu;
     Menu=RECORD
                Libelle:STRING[20];
                Cle:BYTE;
                XPos:BYTE;
                Next:MenuPtr;
                CASE LargSM:BYTE OF
                     TRUE : (SM:MenuPtr);
                     FALSE: (Proc:POINTER);
                END;

 CONST
    AllStop:BOOLEAN=FALSE;

 PROCEDURE AddMenu(VAR Orig:MenuPtr;Nom:STRING;Clef,Position:BYTE;LargeurSM:BYTE;Ptr:POINTER);
 PROCEDURE MenuGo(_M:MenuPtr;_LibCol,_CleCol,_BckCol:BYTE;EachTimeProc:POINTER;
                  Stop_Key,AllStop_Key:CHAR);
 PROCEDURE AfficheBarre(M:MenuPtr;_LibCol,_CleCol,_BckCol,Select:BYTE);
 PROCEDURE Quitte;


IMPLEMENTATION

 VAR _Stop:BOOLEAN;

 PROCEDURE Quitte;
  BEGIN
       _Stop:=TRUE;
       AllStop:=TRUE;
  END; {Quitte}


 FUNCTION NthOption(M:MenuPtr;n:CHAR):MenuPtr;

  BEGIN
       IF n=#1 THEN NthOption:=M
              ELSE NthOption:=NthOption(M^.Next,PRED(n));
  END; {NthOption}


 FUNCTION CurrentMenu(M:MenuPtr;s:STRING):MenuPtr;

  BEGIN
       IF s[1]=#1 THEN IF s[0]=#1 THEN CurrentMenu:=M
                                  ELSE CurrentMenu:=CurrentMenu(M^.SM,Copy(s,2,Length(s)-1))
                  ELSE CurrentMenu:=CurrentMenu(M^.Next,PRED(s[1])+COPY(s,2,LENGTH(s)-1));
  END; {CurrentMenu}


 PROCEDURE AddMenu(VAR Orig:MenuPtr;Nom:STRING;Clef,Position:BYTE;LargeurSM:BYTE;Ptr:POINTER);

  BEGIN
       IF Orig=NIL THEN BEGIN
          NEW(Orig);
          WITH Orig^ DO BEGIN
               Libelle:=Nom;
               Cle:=Clef;
               XPos:=Position;
               Next:=NIL;
               LargSM:=LargeurSM;
               Proc:=Ptr;
          END; {with}
         END {then}
                  ELSE AddMenu(Orig^.Next,Nom,Clef,Position,LargeurSM,Ptr);
  END; {AddMenu}

 PROCEDURE AfficheBarre(M:MenuPtr;_LibCol,_CleCol,_BckCol,Select:BYTE);

  VAR i:BYTE;

  BEGIN
       GOTOXY(1,1);
       TextBackGround(_BckCol);ClrEol;
       i:=1;
       REPEAT
             IF Select=i THEN BEGIN
                                   TextColor(_CleCol);
                                   GOTOXY(M^.XPos-1,1);
                                   WRITE(#16);
                              END;
             TextColor(_LibCol);
             GOTOXY(M^.XPos,1);
             WRITE(M^.Libelle);
             IF Select=i THEN BEGIN
                                   TextColor(_CleCol);
                                   WRITE(#17);
                              END;
             GOTOXY(M^.XPos+M^.Cle-1,1);
             TextColor(_CleCol);
             WRITE(M^.Libelle[M^.Cle]);
             M:=M^.Next;
             INC(i);
       UNTIL M=NIL;
  END; {AfficheBarre}


 PROCEDURE AfficheMenu(M:MenuPtr;s:STRING;_LibCol,_CleCol,_BckCol:BYTE;
                        VAR p:POINTER);
  VAR _YMenu,i:BYTE;

  BEGIN
       _YMenu:=2;
       i:=2;
       WHILE i<ord(s[0])
             DO BEGIN
                     INC(_YMenu,ORD(s[i]));
                     INC(i);
             END;
       i:=0;
       REPEAT INC(i);
              UNTIL CurrentMenu(M,COPY(s,1,LENGTH(s)-1)+CHAR(i))^.Next=NIL;
       TextColor(_LibCol);
       TextBackGround(_BckCol);
       WITH CurrentMenu(M,s)^ DO BEGIN
            GetTextWin(XPos,_YMenu,XPos+CurrentMenu(M,COPY(s,1,LENGTH(s)-1))^.LargSM-1,_YMenu+i+1,p);
            Cadre(XPos,_YMenu,XPos+CurrentMenu(M,COPY(s,1,LENGTH(s)-1))^.LargSM-1,_YMenu+i+1,0);
            FillWin(XPos+1,_YMenu+1,XPos+CurrentMenu(M,COPY(s,1,LENGTH(s)-1))^.LargSM-2,_YMenu+i,_BckCol);
       END; {with}
       i:=1;
       REPEAT
             WITH CurrentMenu(M,s)^ DO BEGIN
                  GOTOXY(XPos+1,_YMenu+i);
                  TextColor(_LibCol);
                  WRITE(Libelle);
                  GOTOXY(Xpos+Cle,_YMenu+i);
                  TextColor(_CleCol);
                  WRITE(Libelle[Cle]);
                  s:=COPY(s,1,LENGTH(s)-1)+SUCC(s[length(s)]);
                  INC(i);
             END;
       UNTIL CurrentMenu(M,s)=NIL;
  END; {AfficheMenu}


 PROCEDURE EffaceMenu(M:MenuPtr;s:STRING;VAR p:POINTER);

  VAR _YMenu,i:BYTE;

  BEGIN
       _YMenu:=2;
       i:=2;
       WHILE i<ord(s[0])
             DO BEGIN
                     INC(_YMenu,ORD(s[i]));
                     INC(i);
             END;
       WITH CurrentMenu(M,s)^ DO
            PutTextWin(p,Xpos,_YMenu);
       FreeTextWin(p);
  END; {EffaceMenu}


 PROCEDURE MenuGo(_M:MenuPtr;_LibCol,_CleCol,_BckCol:BYTE;EachTimeProc:POINTER;
                    Stop_Key,AllStop_Key:CHAR);

  TYPE PtrListPtr=^PtrList;
       PtrList=RECORD
                     Ptr:POINTER;
                     Next:PtrListPtr;
               END;

  VAR _Stk:STRING;
      _Ch:CHAR;
      _i,_YMenu:BYTE;
      _proc:PROCEDURE;
      _ETFlag:BOOLEAN;
      _PList:PtrListPtr;
      _ETProc:PROCEDURE;

   PROCEDURE PushPList;
    VAR pp:PtrListPtr;
    BEGIN
         NEW(pp);
         pp^.Next:=_PList;
         _PList:=pp;
    END; {PushPList}

   PROCEDURE PopPList;
    VAR pp:PtrListPtr;
    BEGIN
         pp:=_PList^.Next;
         DISPOSE(_PList);
         _PList:=pp;
    END; {PopPList}


  PROCEDURE RangeMenus;

   BEGIN
        WHILE _Stk[0]<>#1 DO BEGIN
              EffaceMenu(_M,_Stk,_PList^.Ptr);
              PopPList;
              _Stk:=COPY(_Stk,1,LENGTH(_Stk)-1);
        END; {while}
   END; {RangeMenus}


  BEGIN
       _Stk:=#1;
       AllStop:=FALSE;
       _Stop:=FALSE;
       _PList:=NIL;
       AfficheBarre(_M,_LibCol,_CleCol,_BckCol,1);
       @_ETProc:=EachTimeProc;
    REPEAT
       IF (@_ETProc<>NIL) AND _ETFlag
          THEN _ETProc;
       _ETFlag:=FALSE;
       _Ch:=READKEY;
       CASE _Ch OF
            #0 : BEGIN
                      _Ch:=READKEY;
                      IF _Ch=Stop_Key THEN
                                         BEGIN
                                              RangeMenus;
                                              _Stop:=TRUE;
                                         END; {begin}

                      IF _Ch=AllStop_Key THEN
                                            BEGIN
                                                 RangeMenus;
                                                 _Stop:=TRUE;
                                                 AllStop:=TRUE;
                                            END; {begin}
                CASE _Ch OF
                     #75 : {gauche}
                          CASE _Stk[0] OF
                            #1 : BEGIN
                                      IF _Stk[1]>#1
                                         THEN _Stk[1]:=PRED(_Stk[1])
                                         ELSE WHILE NthOption(_M,_Stk[1])^.Next
                                                                          <>NIL
                                             DO _Stk[1]:=SUCC(_Stk[1]);
                                      AfficheBarre(_M,_LibCol,_CleCol,_BckCol,Ord(_Stk[1]));
                                 END;{#2}
                            #2 : BEGIN
                                      EffaceMenu(_M,_Stk,_PList^.Ptr);
                                      PopPList;
                                      IF _Stk[1]>#1
                                         THEN _Stk[1]:=PRED(_Stk[1])
                                         ELSE WHILE NthOption(_M,_Stk[1])^.Next
                                                                          <>NIL
                                             DO _Stk[1]:=SUCC(_Stk[1]);
                                      AfficheBarre(_M,_LibCol,_CleCol,_BckCol,Ord(_Stk[1]));
                                      _Stk[2]:=#1;
                                      PushPList;
                                      AfficheMenu(_M,_Stk,_LibCol,_CleCol,_BckCol,
                                                                   _PList^.Ptr);
                                 END;{#2}
                          END;{CASE}
                     #77 : {droite}
                          CASE _Stk[0] OF
                            #1 : BEGIN
                                      IF NthOption(_M,_Stk[1])^.Next<>NIL
                                         THEN _Stk[1]:=SUCC(_Stk[1])
                                         ELSE _Stk[1]:=#1;
                                      AfficheBarre(_M,_LibCol,_CleCol,_BckCol,Ord(_Stk[1]));
                                 END;{begin}
                            #2 : BEGIN
                                      EffaceMenu(_M,_Stk,_PList^.Ptr);
                                      PopPList;
                                      IF NthOption(_M,_Stk[1])^.Next<>NIL
                                         THEN _Stk[1]:=SUCC(_Stk[1])
                                         ELSE _Stk[1]:=#1;
                                      AfficheBarre(_M,_LibCol,_CleCol,_BckCol,Ord(_Stk[1]));
                                      _Stk[2]:=#1;
                                      PushPList;
                                      AfficheMenu(_M,_Stk,_LibCol,_CleCol,_BckCol,_PList^.Ptr);
                                 END;{begin}
                          END;{case}
                     #80 : {bas}
                           IF _Stk[0]=#1 THEN BEGIN
                                                  _Stk:=_Stk+#1;
                                                  PushPList;
                                                  AfficheMenu(_M,_Stk,_LibCol,_CleCol,_BckCol,_PList^.Ptr);
                                             END
                                     ELSE IF CurrentMenu(_M,_Stk)^.Next<>NIL
                                             THEN _Stk[LENGTH(_Stk)]:=SUCC(_Stk[LENGTH(_Stk)])
                                             ELSE _Stk[LENGTH(_Stk)]:=#1;
                     #72 : {haut}
                           IF _Stk[0]<>#1 THEN
                           IF _Stk[LENGTH(_Stk)]>#1 THEN _Stk[LENGTH(_Stk)]:=PRED(_Stk[LENGTH(_Stk)])
                                                  ELSE WHILE CurrentMenu(_M,_Stk)^.Next<>NIL
                                                            DO _Stk[LENGTH(_Stk)]:=SUCC(_Stk[LENGTH(_Stk)]);
                  END; {begin dans case #0}
                 END; {case Ch dans case #0}
            #27 : {ESC}
                  IF _Stk[0]>#1 THEN BEGIN
                                         EffaceMenu(_M,_Stk,_PList^.Ptr);
                                         PopPList;
                                         _Stk:=COPY(_Stk,1,LENGTH(_Stk)-1);
                                    END;
            #13 : {Return}
                  IF CurrentMenu(_M,_Stk)^.LargSM=0
                     THEN BEGIN
                               @_proc:=CurrentMenu(_M,_Stk)^.Proc;
                               RangeMenus;
                               IF @_proc<>NIL THEN _proc;
                               AfficheBarre(_M,_LibCol,_CleCol,_BckCol,Ord(_Stk[1]));
                               _ETFlag:=TRUE;
                          END
                     ELSE BEGIN
                               _Stk:=_Stk+#1;
                               PushPList;
                               AfficheMenu(_M,_Stk,_LibCol,_CleCol,_BckCol,_PList^.Ptr);
                          END; {ift}

       END; {case}

     IF _Stk[0]<>#1 THEN BEGIN
       _YMenu:=2;
       _i:=2;
       WHILE _i<ord(_Stk[0])
             DO BEGIN
                     INC(_YMenu,ORD(_Stk[_i]));
                     INC(_i);
             END;
       _i:=0;
       REPEAT INC(_i);
              UNTIL CurrentMenu(_M,COPY(_Stk,1,LENGTH(_Stk)-1)+CHAR(_i))^.Next=NIL;
       TextColor(_LibCol);
       WITH CurrentMenu(_M,_Stk)^ DO
       Cadre(XPos,_YMenu,
         XPos+CurrentMenu(_M,COPY(_Stk,1,LENGTH(_Stk)-1))^.LargSM-1,_YMenu+_i+1,0);
       TextColor(_CleCol);
       GOTOXY(CurrentMenu(_M,_Stk)^.XPos,_YMenu+Ord(_Stk[LENGTH(_Stk)]));
       WRITE(#16);
       GOTOXY(CurrentMenu(_M,_Stk)^.XPos-1+
        CurrentMenu(_M,COPY(_Stk,1,LENGTH(_Stk)-1))^.LargSM,_YMenu+Ord(_Stk[LENGTH(_Stk)]));
       WRITE(#17);
     END; {if s[0]}
    UNTIL _Stop;
  END; {MenuGo}

END.