{***************************************************************************
 *                                                                         *
 *            Unit de gestion de l'cran texte de POWER-GRAPH             *
 *                                                                         *
 ***************************************************************************}

{$A+,B-,D+,E-,F+,G+,I+,L+,N-,O-,R-,S+,V-,X-}
{$M 16384,0,655360}

UNIT PG_TxScr;

INTERFACE

 USES
     Crt,
     DTWin,

     PG_Parch,
     PG_Ptrs;

 CONST
      PosInTree:STRING[3]='';
      TreeWin:TWinPtr=NIL;
      TreeHi:BYTE=15;

 PROCEDURE MakeTreeWin(VAR p:TWinPtr;L:ProjListPtr);
 PROCEDURE GrayOnBlack;
 FUNCTION One_XYZ_to_Str(P:XYZPtr):STRING;

IMPLEMENTATION

 PROCEDURE MakeTreeWin(VAR p:TWinPtr;L:ProjListPtr);

  VAR x,y:BYTE;
      pr:ProjectPtr;
      eq:EquPtr;

  BEGIN
       IF l=NIL THEN EXIT;
       y:=1;
       WITH p^ DO ModifTWin(p,1,2,80,TreeHi,Cadre,XPos,YPos);
       ResetTWin(p,80,0);
       AddTWinLines(p,ParchLength(p^.Page)+1,1);
       REPEAT
             x:=1;
             TWinWrite(p,x,y,l^.Name+' : ');
             l^.YPos:=y;
             INC(x,LENGTH(l^.Name)+3);
             pr:=l^.Proj;
             REPEAT
                   TWinWrite(p,x,y,pr^.Name);
                   pr^.XPos:=x;pr^.YPos:=y;
                   INC(x,LENGTH(pr^.Name));
                   IF pr^.Cond<> NIL THEN
                      BEGIN
                           TWinWrite(p,x,y,' / ');
                           INC(x,3);
                           eq:=pr^.Cond;
                           REPEAT
                                 TWinWrite(p,x,y,eq^.Name);
                                 eq^.XPos:=x;eq^.YPos:=y;
                                 INC(x,Length(eq^.Name));
                                 IF eq^.Next<>NIL THEN
                                    BEGIN
                                         TWinWrite(p,x,y,', ');
                                         INC(x,2);
                                    END;
                                 eq:=eq^.Next;
                           UNTIL eq=NIL;
                      END;
                   IF (pr^.next<>NIL) OR (l^.Next<>NIL)
                      THEN AddTWinLines(p,ParchLength(p^.Page)+1,1);
                   INC(y);x:=LENGTH(l^.Name)+4;
                   pr:=pr^.Next
             UNTIL pr=NIL;
             l:=l^.Next;
       UNTIL l=NIL;
  END; {MakeTreeWin}


 PROCEDURE GrayOnBlack;

  BEGIN
       TextColor(LightGray);
       TextBackGround(Black);
  END; {GrayOnBlack}


 FUNCTION One_XYZ_to_Str(P:XYZPtr):STRING;

  VAR s,ss:STRING;

  BEGIN
       s:='';
       IF (P^.c<>1) AND (P^.x+P^.y+P^.z<>0) THEN
          BEGIN
               STR(P^.c,ss);
               s:=s+ss+' ';
          END;
       IF P^.x<>0 THEN
          BEGIN
               s:=s+'X';
               IF P^.x<>1 THEN
                  BEGIN
                       STR(P^.x,ss);
                       s:=s+ss+' ';
                  END;
          END;
       IF P^.y<>0 THEN
          BEGIN
               s:=s+'Y';
               IF P^.y<>1 THEN
                  BEGIN
                       STR(P^.y,ss);
                       s:=s+ss+' ';
                  END;
          END;
       IF P^.z<>0 THEN
          BEGIN
               s:=s+'Z';
               IF P^.z<>1 THEN
                  BEGIN
                       STR(P^.z,ss);
                       s:=s+ss+' ';
                  END;
          END;
       IF (P^.Next<>NIL) AND (P^.Next^.c>0)
          THEN s:=ss+'+ ';
       One_XYZ_to_Str:=s;
  END; {One_XYZ_to_Str}

END.
